*if(strcasecmp(GenData(LMACHN_problem),"Off")!=0)
*#####################################################
*#LMACHN MODULE PREFIXES: lmn LMACHN *This must be on line 3
*#####################################################
*realformat "%16.6f"
*intformat "%8i"
$------------------------------------------------------------
PHYSICAL_PROBLEM
$------------------------------------------------------------ 
PROBLEM_DEFINTION  
  TEMPORAL_DERIVATIVES: *GenData(LMN_temporal_derivatives)  
  CONVECTIVE_TERM:      *GenData(LMN_convective_term)  
  VISCOUS_TERM:         *GenData(LMN_viscous_term)  
*if(strcasecmp(GenData(LMN_Gravity_acceleration),"Off")==0) 
  GRAVITY:              NORM: 0.0, GX: 0.0, GY: 0.0,  GZ: 0.0  
*else
  GRAVITY:              NORM: *GenData(LMN_Norm_gravity), \
                       GX:   *GenData(LMN_X_gravity), \
                       GY:   *GenData(LMN_Y_gravity), \
                       GZ:   *GenData(LMN_Z_gravity)  
*endif
  SOURCE_TERMS:           *GenData(LMN_Heat_Source), VALUE: *GenData(LMN_Source_value)  
END_PROBLEM_DEFINITION
$------------------------------------------------------------
PROPERTIES
  EQNST= 	    *GenData(LMN_Equation_of_state)
*if(strcasecmp(GenData(LMN_Equation_of_state),"Ideal_gas")==0)
  GAS_CONSTANT=	    *GenData(LMN_Density_R)
*else
  TEXPANSION=       *GenData(LMN_Thermal_expansion)  
*endif
  DENSITY=          *GenData(LMN_Initial_density)  
  SPECIFIC_HEAT=    *GenData(LMN_Cp_heat)
  VISCOSITY=        *GenData(LMN_Viscosity)  
  TCONDUCTION=      *GenData(LMN_Thermal_conductivity)  
  TPRESSURE=        *GenData(LMN_Thermodynamic_pressure)  
  REACTION=         *GenData(LMN_Reaction)
END_PROPERTIES  

END_PROBLEM_DEFINITION  
$------------------------------------------------------------
END_PHYSICAL_PROBLEM  
$------------------------------------------------------------
NUMERICAL_TREATMENT
  STABILITY_CONSTANTS:   *GenData(LMN_Tau_1) *GenData(LMN_Tau_2)
  TEST_FUNCTION_STABILIZATION: *GenData(LMN_Stabilization_Method)
  ACCURACY_IN_TIME_SGS:  *GenData(LMN_Time_Accuracy_SGS) 
  TYPE_OF_STABILIZATION: *GenData(LMN_Type_of_stabilization)  
  PROJECTION_TYPE=       *GenData(LMN_Projection_Type)
  TRACKING_SUBSCALES:    *GenData(LMN_Tracking_subscales)   
  NON_LINEARITY_SGS:     *GenData(LMN_NonLinear_SGS)  ITERATIONS: *GenData(LMN_NonLinearSGS_Iterations)  TOLERANCE: *GenData(LMN_NonLinearSGS_Tolerance) *GenData(LMN_Scheme_SGS)
  RELAXATION_SGS:        *GenData(LMN_Relaxation_SGS)
  T1_SCHEME:             *GenData(LMN_Time_integration_type)   
  T1_EULER_STEPS:        *GenData(LMN_Euler_steps) 
  SAFETY_FACTOR:         *GenData(LMN_Safety_factor)  
  LINEARIZATION_METHOD:  *GenData(LMN_Linearization_method) STEPS: *GenData(LMN_Picard_Steps) 
  STEADY_STATE_TOLER:    *GenData(LMN_Steady_state_tolerance)   
  NORM_OF_CONVERGENCE:   *GenData(LMN_Norm_of_convergence)   
  MAXIMUM_NUMBER_OF_IT:  *GenData(LMN_Number_of_internal_iterations)
  CONVERGENCE_TOLERANCE: *GenData(LMN_Convergence_tolerance)
*if(strcasecmp(GenData(LMN_Fix_pressure_on_node),"Yes")==0) 
  EPRES:          *GenData(LMN_pres_penalty_value)  
*endif
  ERROR_ESTIMATOR:       *GenData(LMN_Error_Estimator), MAX_ERROR: *GenData(LMN_Error_Limits_Max), MIN_ERROR: *GenData(LMN_Error_Limits_Min), CRITERIA: *GenData(LMN_Error_Criteria)    
END_NUMERICAL_TREATMENT  
$------------------------------------------------------------
OUTPUT_&_POST-PROCESS  
 PNTBC = *GenData(LMN_pntBC)
 START_POSTPROCES_AT           STEP =*GenData(LMN_Start_postprocess_at_step)
 POSTPROCESS VELOCITY,         STEPS=*GenData(LMN_Postprocess_velocity)
 POSTPROCESS PRESSURE,         STEPS=*GenData(LMN_Postprocess_pressure)
 POSTPROCESS TEMPERATURE,      STEPS=*GenData(LMN_Postprocess_temperature)
 POSTPROCESS DENSITY,          STEPS=*GenData(LMN_Postprocess_density)
 POSTPROCESS STREAMLINES,      STEPS=*GenData(LMN_Postprocess_streamlines)
 POSTPROCESS HEATFLUX,         STEPS=*GenData(LMN_Postprocess_heat_flux)
 POSTPROCESS VeSGS,            STEPS=*GenData(LMN_Postprocess_VeSGS)
 POSTPROCESS TeSGS,            STEPS=*GenData(LMN_Postprocess_TeSGS)
 POSTPROCESS RESIDUAL,         STEPS=*GenData(LMN_Postprocess_Residual)
 POSTPROCESS REPRO,            STEPS=*GenData(LMN_Postprocess_Repro)
 PNTBC:			       *GenData(PNTBC)
*if(strcasecmp(GenData(LMN_Forces_moments),"On")==0) 
 FORCES_AND_MOMENTS:    FX:   *GenData(LMN_X_force_coeff), \
                        FY:   *GenData(LMN_Y_force_coeff), \
                        FZ:   *GenData(LMN_Z_force_coeff), \
                        MX:   *GenData(LMN_X_momen_coeff), \
                        MY:   *GenData(LMN_Y_momen_coeff), \
                        MZ:   *GenData(LMN_Z_momen_coeff), \
                        OX:   *GenData(LMN_X_momen_orig), \
                        OY:   *GenData(LMN_Y_momen_orig), \
                        OZ:   *GenData(LMN_Z_momen_orig), \
                        FQ:   *GenData(LMN_heat_flux_coeff)
*else
*endif
*if(*GenData(LMN_Point_Tracking,int))
*set var N=GenData(LMN_Tracking_Coor,int)
*set var numP=operation(N/3)
 TRACKING
*for(i=1;i<=N;i=i+3)
*if(i==1) 
 POINT *numP 
*endif 
*GenData(LMN_Tracking_Coor,*i) *GenData(LMN_Tracking_Coor,*operation(i+1)) *GenData(LMN_Tracking_Coor,*operation(i+2)) 
*end for
 END_TRACKING
*endif
END_OUTPUT_&_POST_PROCESS
$------------------------------------------------------------
BOUNDARY_CONDITIONS, \
*if(strcasecmp(GenData(LMN_fix_pressure_mode),"Yes")==0)
      FIX_PRESSURE=*GenData(LMN_Fix_pressure_on_node), \
*elseif(strcasecmp(GenData(LMN_fix_pressure_mode),"No")==0)
      DONT_FIX_PRESSURE, \
*endif
 CONSTANT_BOUNDARY_CONDITIONS
  INCLUDE *tcl(FemussProblemName).lmn.fix
END_BOUNDARY_CONDITIONS  
$------------------------------------------------------------
*endif
