*if(strcasecmp(GenData(WAVETM_problem),"Off")!=0)
*#####################################################
*#WAVETM MODULE PREFIX: wtm WAVETM *This must be on line 3
*#####################################################
*realformat "%16.6f"
*intformat "%8i"
$------------------------------------------------------------
PHYSICAL_PROBLEM
$------------------------------------------------------------
PROBLEM_DEFINTION
 TEMPORAL_DERIVATIVES: *GenData(WTM_temporal_derivatives)
END_PROBLEM_DEFINITION
$------------------------------------------------------------
PROPERTIES
  MU_P             *GenData(WTM_muuup)
  MU_U             *GenData(WTM_muuuu)
  $SPEED_OF_WAVE    *GenData(WTM_speew)
  $START_FREQUENCY  *GenData(WTM_stafr)
  $END_FREQUENCY    *GenData(WTM_endfr)
END_PROPERTIES
$------------------------------------------------------------
END_PHYSICAL_PROBLEM
$------------------------------------------------------------
NUMERICAL_TREATMENT
  WEAK_FORM                 *GenData(WTM_weakt) $ {1,2,3}
  BOU_INTEGRAL              *GenData(WTM_bouin) $ {0,1}
  STA_CONSTANT              *GenData(WTM_ctauu) $ {P1:0.05}
  DIAMETER                  *GenData(WTM_diame) $ characteristic length of the domain
  STAB_METHOD               *GenData(WTM_sgsty) $ {1:ASGS,2:OSS lumped,3:OSS Consistent,4:OSS consistent time explicit}
  PROJECTION_TYPE           *GenData(WTM_Projection_Type) $ Lumped, L2
  RES_BOUN_FIX              *GenData(WTM_resbo) $ {0,1:residual set to zero on boundary}
  BOSGS                     *GenData(WTM_bosgs) $ {0:no boundary subgrid scales}
  T1_SCHEME                 *GenData(WTM_tesc0) $ {BDF1,BDF2,CN,TR}
  T1_EULER_STEPS            *GenData(WTM_neule) $ number of backward euler steps, 0 by default
  TEMPORAL_TERM_WEIGHT      *GenData(WTM_wtemp) $ {all,galerkin}
  FORCE_TERM_WEIGHT         *GenData(WTM_wforc) $ {all,galerkin}
  ELMAT_RECOMPUTE           *GenData(WTM_elmat) $ {0,1}
  SAFETY_FACTOR             *GenData(WTM_safet) $ automatic time step size safety factor
  STEADY_STATE_TOLER:       *GenData(WTM_sstol) $ steady state tolerance
  MAXIMUM_NUMBER_OF_IT      *GenData(WTM_maxit) $ non linearity max iterations
  CONVERGENCE_TOLERANCE     *GenData(WTM_cotol) $ non linearity tolerance
$  ALGEBRAIC_SOLVER          GMRES
$  SOLVER_ITERATIONS         200
$  TOLERANCE_OF_CONVER       1.0e-10
$  KRYLOV_DIMENSION          100
$  $FIXED                    felap_ipara_hyw(44){int}
$  THRESHOLD                 0.0
$  FILLING                   50
$  $DYN_FILLING              On   30
$  $DIAPC                    <Off,On>    <0,1>kfl_diapc_hyw{int}
$  MESH_CHECK                On
$  $ELMAT                    1  $ 0: do not recalculate matrix, 1: recalculate matrix
END_NUMERICAL_TREATMENT
$------------------------------------------------------------
OUTPUT_&_POST-PROCESS
 START_POSTPROCES_AT           STEP  *GenData(WTM_Start_postprocess_at_step)
 POSTPROCESS P                 STEPS *GenData(WTM_Postprocess_pressure)
 POSTPROCESS U                 STEPS *GenData(WTM_Postprocess_velocity)
 PNTBC:			       *GenData(PNTBC)
 BOU_VALUES                    *GenData(WTM_Postprocess_bouva) $ {on,off}
 $TRACKING $ do not use nodal and point at the same time
   $NODAL    1     4457 
   $POINT    1     -0.003  0.0  0.0   
 $END_TRACKING
END_OUTPUT_&_POST_PROCESS
$------------------------------------------------------------
BOUNDARY_CONDITIONS 
  INCLUDE *tcl(FemussProblemName).wtm.fun
  INCLUDE *tcl(FemussProblemName).wtm.fix
END_BOUNDARY_CONDITIONS
$------------------------------------------------------------
*endif
