*if(strcasecmp(GenData(NSTPRI_problem),"Off")!=0)
*#####################################################
*#NSTPRI MODULE PREFIXES: nsp NSTPRIOMP *This must be on line 3
*#####################################################
*realformat "%16.6f"       $ Formats for reals and integers
*intformat "%8i"
$------------------------------------------------------------
PHYSICAL_PROBLEM
$------------------------------------------------------------ 
PROBLEM_DEFINTION  
  TEMPORAL_DERIVATIVES: *GenData(NSTPRI_Temporal_derivatives)     $ Transient problem: On/Off
*if(strcasecmp(GenData(NSTPRI_Gravity_acceleration),"Off")==0) 
 GRAVITY:     NORM: 0.0, GX: 0.0, GY: 0.0,  GZ: 0.0            $ Acceleration of gravity
*else
 GRAVITY:     NORM: *GenData(NSTPRI_Norm_gravity), \           $ Acceleration of gravity norm 
              GX:   *GenData(NSTPRI_X_gravity), \              $ Components
              GY:   *GenData(NSTPRI_Y_gravity), \
              GZ:   *GenData(NSTPRI_Z_gravity)  
*endif
*if(strcasecmp(GenData(NSTPRI_Heat_Sources),"Off")==0)         $ Heat sources in energy equation
 HEAT_SOURCE:          0.0  
*else
 HEAT_SOURCE:          *GenData(NSTPRI_Value_heat_source)
*endif
*if(strcasecmp(GenData(NSTPRI_Confined_Flow),"On")==0)         $ Confined flow
 CONFINED_FLOW_PARAMETER: *GenData(NSTPRI_Pressure_Penalization_Parameter)
*endif
*if(strcasecmp(GenData(NSTPRI_Adaptive_Time_Window),"On")==0)  $ Time window filtering. Mean computation
 TIME_WINDOW:     *GenData(NSTPRI_Adaptive_Time_Window)
   DELAY       =  *GenData(NSTPRI_Time_Window_Delay_Steps)
   FREQUENCY   =  *GenData(NSTPRI_Filtering_Frequency)
 END_TIME_WINDOW
*endif
END_PROBLEM_DEFINITION
$------------------------------------------------------------
PROPERTIES
  EQNST= 		 *GenData(NSTPRI_Equation_of_state)    $ Equation of state: ideal gas
  CPHEAT=       *GenData(NSTPRI_Cp_heat)              $ Specific heat at constant pressure
  CVHEAT=       *GenData(NSTPRI_Cv_heat)              $ Specific heat at constant volume
  VISCOSITY=    *GenData(NSTPRI_Model_Viscosity),\    $ Viscosity model: constant, Sutherland's, etc
                *GenData(NSTPRI_Viscosity)
  THERMAL_COND= *GenData(NSTPRI_Model_Thermal_conductivity),\ $ Thermal conduct: constant, temperature dependent
                *GenData(NSTPRI_Thermal_conductivity)
*if(strcasecmp(GenData(NSTPRI_Atmospheric_Properties),"Off")==0) 
  ATMOSPHERIC_PROPERTIES:  Off                       $ Atmospheric properties P_atm, T_atm
*else
  ATMOSPHERIC_PROPERTIES:  *GenData(NSTPRI_Atmospheric_Properties) 
      ATM_PRESSURE:     *GenData(NSTPRI_Atmospheric_Pressure_value) 
      ATM_TEMPERATURE:  *GenData(NSTPRI_Atmospheric_Temperature_value)     
  END_ATMOSPHERIC_PROPERTIES
*endif
END_PROPERTIES  
$------------------------------------------------------------
END_PHYSICAL_PROBLEM  
$------------------------------------------------------------
NUMERICAL_TREATMENT    
*if(strcasecmp(GenData(NSTPRI_Stabilization),"VMS")==0)        $ Variational MultiScale method / Off
   STABILIZATION: *GenData(NSTPRI_Type_of_stabilization)       $ ASGS or OSGS
      TRANSIENT_SUBSCALES: *GenData(NSTPRI_Transient_Subscales)         $ Time dependent subscales
*if(strcasecmp(GenData(NSTPRI_Type_of_stabilization),"OSGS")==0)
*if(strcasecmp(GenData(NSTPRI_When_Compute_FE_Projection),"Previous_Nonlinear_Iteration")==0)
      COMPUTE_FINITE_ELEMENT_PROJECTION: Iteration       $ Iteration/Time_Step
*elseif(strcasecmp(GenData(NSTPRI_When_Compute_FE_Projection),"Previous_Time_Step")==0)
      COMPUTE_FINITE_ELEMENT_PROJECTION: Time_Step
*endif      
*endif 
      STABILITY_CONSTANTS: *GenData(NSTPRI_Tau_1_Constant) *GenData(NSTPRI_Tau_2_Constant) 
   END_STABILIZATION 
*endif
   PROJECTION_TYPE:     *GenData(NSTPRI_Projection_Type)       $ Lumped or L2 projection
*if(strcasecmp(GenData(NSTPRI_Linearization_method),"Picard")==0) 
   LINEARIZATION_METHOD:  Picard       $ Linearization method
*else
   LINEARIZATION_METHOD:  *GenData(NSTPRI_Linearization_method)
*endif
  MAXIMUM_NUMBER_OF_IT:  *GenData(NSTPRI_Nonlinear_iterations)       $ Maximum non-linear iterations
  CONVERGENCE_TOLERANCE: *GenData(NSTPRI_Convergence_tolerance)         $ Relative convergence tolerance
  NORM_OF_CONVERGENCE:   *GenData(NSTPRI_Norm_of_convergence)        $ Norm: L2,L1,L-inf
*if(strcasecmp(GenData(NSTPRI_Subrelax_strategy),"Off")==0) 
  SUBRELAX_STRATEGY:     Off        $ Subrelaxation and parameter
*else
  SUBRELAX_STRATEGY:     *GenData(NSTPRI_Subrelax_strategy) *GenData(NSTPRI_Subrelax_value)  
*endif
*if(strcasecmp(GenData(NSTPRI_Temporal_derivatives),"On")==0)
  T1_SCHEME:            *GenData(NSTPRI_Time_Integrator)          $ Time scheme: BDF1,BDF2,BDF3,CN
*if(strcasecmp(GenData(NSTPRI_Time_Integrator),"BDF1")!=0)
  T1_EULER_STEPS:       *GenData(NSTPRI_Euler_steps)              $ For starting 2nd or 3rd order schemes
*endif
  STEADY_STATE_TOLER:   *GenData(NSTPRI_Steady_state_tolerance)   $ Steady state tolerance 
  SAFETY_FACTOR:        *GenData(NSTPRI_Safety_factor_dt_critical)$ dt/dt_critic
*endif
END_NUMERICAL_TREATMENT  
$------------------------------------------------------------
OUTPUT_&_POST-PROCESS  
 START_POSTPROCES_AT           STEP =*GenData(NSTPRI_Start_postprocess_at_step)
 POSTPROCESS VELOCITY,         STEPS=*GenData(NSTPRI_Postprocess_velocity)
 POSTPROCESS PRESSURE,         STEPS=*GenData(NSTPRI_Postprocess_pressure)
 POSTPROCESS TEMPERATURE,      STEPS=*GenData(NSTPRI_Postprocess_temperature)
 POSTPROCESS DENSITY,          STEPS=*GenData(NSTPRI_Postprocess_density)
 POSTPROCESS SUBSCALES,        STEPS=*GenData(NSTPRI_Postprocess_Subscales)
 POSTPROCESS MACH,             STEPS=*GenData(NSTPRI_Postprocess_Mach_Number)
*if(*GenData(NSTPRI_Forces_Moments_HeatFlux,int)) 
 FORCES_AND_MOMENTS_AND_HEAT_FLUX: \
 OX: *GenData(NSTPRI_X_momen_orig), OY: *GenData(NSTPRI_Y_momen_orig), OZ: *GenData(NSTPRI_Z_momen_orig)
*endif
*if(*GenData(NSTPRI_Point_Tracking,int))
*set var N=GenData(NSTPRI_Tracking_Coor,int)
*set var numP=operation(N/3)
 TRACKING
*for(i=1;i<=N;i=i+3)
*if(i==1) 
 POINT *numP 
*endif 
*GenData(NSTPRI_Tracking_Coor,*i) *GenData(NSTPRI_Tracking_Coor,*operation(i+1)) *GenData(NSTPRI_Tracking_Coor,*operation(i+2)) 
*end for
 END_TRACKING
*endif
END_OUTPUT_&_POST_PROCESS  
$------------------------------------------------------------
BOUNDARY_CONDITIONS, \
        CONTINUE
 INCLUDE *tcl(FemussProblemName).nsp.fix
END_BOUNDARY_CONDITIONS  
$------------------------------------------------------------
*endif
