*realformat "%16.6f"
*intformat "%8i"
$-------------------------------------------------------------------
RUN_DATA
  Femuss:                 *GenData(Title)
  MEMCHECK:                   *GenData(Memcheck)
  OUTPUT_FORMAT:              *GenData(Output_format)
  OUTPUT_COMPRESSION:         *GenData(Output_compression)
  IO_FORMAT:                  *GenData(IO_Format)
  CUSTOMER:                   Universal
  COMMUNICATOR_LIBRARY:       *GenData(Communicator_Library)
  ORDERING_LIBRARY:           *GenData(Ordering_Library)
  PARTITIONING_NUMBERING:     *GenData(Partitioning_Library)
  REBALANCE_NUMBERING:        *GenData(RebalancePartitioning_Library)
  MPICommunicationsType:      *GenData(MPICommunicationsType)
  FLUSH_TO_DISK:              *GenData(Flush_To_Disk)
  
  POSTPROCESS:
     START_POSTPROCESS_AT:         *GenData(Start_Postprocess_At_Step)
     PROCESSOR_POSTPROCESS_EVERY:  *GenData(Postprocess_Processor_Every)
     DUPLICATE_INTERFACE_ELEMENTS: *GenData(DuplicateInterfaceElements)
  END_POSTPROCESS
END_RUN_DATA
$-------------------------------------------------------------------
PROBLEM_DATA
*if(strcasecmp(GenData(Time_coupling),"Global_from_critical")==0)
  TIME_COUPLING:          Global, From_critical
*elseif(strcasecmp(GenData(Time_coupling),"Global_prescribed")==0)
  TIME_COUPLING:          Global, Prescribed
*elseif(strcasecmp(GenData(Time_coupling),"ForPC")==0)
  TIME_COUPLING:          Global, FORPC, MULDT =0.10 4 1.15 0.7 0.10 1.0
*elseif(strcasecmp(GenData(Time_coupling),"Local")==0)
  TIME_COUPLING:          Local
*elseif(strcasecmp(GenData(Time_coupling),"Global_function")==0)
  TIME_COUPLING:          Global, Function: *GenData(Time_function_1) *GenData(Time_function_2) *GenData(Time_function_3) *GenData(Time_function_4) *GenData(Time_function_5) 
*endif
*\if(strcasecmp(GenData(PLCd_problem),"Off")==0)
  TIME_INTERVAL=          *GenData(Time_initial), *GenData(Time_final)  
  TIME_STEP_SIZE=         *GenData(Time_step_size)  
  NUMBER_OF_STEPS=        *GenData(Maximum_number_of_steps)   
*\else
*\set var N=GenData(PLCd_Substages_Data,int)
*\set var NS=N/3
*\set var finaltime = 0.0
*\for(j=1;j<=NS;j=j+1)
*\set var aux = GenData(PLCd_Substages_Data,operation(j*3))
*\set var finaltime = operation(finaltime+aux)
*\end for
*\  TIME_INTERVAL=          *GenData(Time_initial), *finaltime
*\  TIME_STEP_SIZE=         *GenData(Time_step_size)  
*\  NUMBER_OF_STEPS=        *GenData(Maximum_number_of_steps)
*\endif
  REMESHING_STRATEGY:     *GenData(Remeshing_strategy)
*if(strcasecmp(GenData(Remeshing_strategy),"Off")!=0)
     ALGORITHM:           *GenData(Remeshing_algorithm)
     AFTER_BLOCK=         *GenData(Remeshing_after_block)
     *if(strcasecmp(GenData(MSH_Axes_rotation),"Off")==0)
     AXES_ROTATION:        NORM: 0.0, OX: 0.0, OY: 0.0,  OZ: 0.0  
*else
     AXES_ROTATION:        NORM: *GenData(MSH_Omega_norm),  \
		       OX:   *GenData(MSH_X_omega),  \
		       OY:   *GenData(MSH_Y_omega),  \
		       OZ:   *GenData(MSH_Z_omega)  
     CENTER_ROTATION:      *GenData(MSH_Rotation_center)  
*endif
  END_REMESHING_STRATEGY 
*endif
  ADAPTIVE_MESH_REFINEMENT:   *GenData(Adaptive_Mesh_Refinement) *GenData(Refinement_Leader) *GenData(Refinement_Params) REBALANCING_RATIO *GenData(Rebalancing_Ratio) *GenData(TwoOneBalancing) Max_Refinement_Level: *GenData(MaximumRefinementLevel) ProgressiveRefinementLevel: *GenData(ProgressiveRefinementLevel) Delay: *GenData(AdaptiveDelay) NIterations: *GenData(AdaptiveIterations=) DO_REBALANCING_AT_EACH_ITERATION: *GenData(DoRebalancingAtEachIteration)
*if(strcasecmp(GenData(Refinement_Leader),"MULTI")==0)
  MULTI_Criterias: *GenData(MULTI_NCriterias_and_Criterias)
*endif
  INITIAL_UNIFORM_REFINEMENT:  *GenData(Initial_Uniform_Refinement) *GenData(Number_of_levels)
  MULTICOMM ADAPTIVE: *GenData(MultiCommAdaptive) 
  INTERPOLATOR TOLERANCE:    *GenData(Interpolator_tolerance) MAXITER: *GenData(Interpolator_MaximumIterations) FACTOR: *GenData(Interpolator_IterationFactor) OVERLAP_RANGE_ABS_TOL: *GenData(Interpolator_OverlapRangeAbsTolerance)
  CP_CONVERGENCE=    *GenData(Coupling_Convergence)
  CP_MAX_ITERATIONS GLOBAL= *GenData(CP_Max_Iterations_Global)
  CP_MAX_ITERATIONS INTERNAL= *GenData(CP_Max_Iterations_Internal)

*\
*\ NSTINC ----------------------------------------------------------
*\ 
*if(strcasecmp(GenData(NSTINC_problem),"Off")!=0)
*if(strcasecmp(GenData(NSTINC_do_ROM),"Yes")==0)
  PODROM_NSTINC_PROBLEM:         On     MODNAME: *GenData(NSTINC_module_nickname)
    DELAY_STEPS:          *GenData(NSTINC_PODROM_Delay_Steps)
    RESTART:              *GenData(NSTINC_Restart) $Initial, Interpolated
*if(strcasecmp(GenData(NSTINC_Restart),"Interpolated")==0)
    OLD_CASE_NAME:      *GenData(NSTINC_Old_case_name)
*endif
    PHYSICAL_PROBLEM:     Navier-Stokes
*endif
  NSTINC_PROBLEM:       *GenData(NSTINC_problem) MODNAME: *GenData(NSTINC_module_nickname)
    DELAY_STEPS:          *GenData(NSTINC_Delay_Steps)
*if(strcasecmp(GenData(NSTINC_Preliminary_Write_Average_Values),"On")==0)
    PRELIMINARY_RUN:      *GenData(NSTINC_Preliminary_run) FREQUENCY=*GenData(NSTINC_Preliminary_output_frequency) AVERAGE
*else
    PRELIMINARY_RUN:      *GenData(NSTINC_Preliminary_run) FREQUENCY=*GenData(NSTINC_Preliminary_output_frequency) 
*endif 
    RESTART:              *GenData(NSTINC_Restart) $Initial, Interpolated
*if(strcasecmp(GenData(NSTINC_Restart),"Interpolated")==0)
    OLD_CASE_NAME:      *GenData(NSTINC_Old_case_name)
*endif
*if(strcasecmp(GenData(NSTINC_algorithm),"Monolithic")==0)
    ALGORITHM:            Monolithic   
*elseif(strcasecmp(GenData(NSTINC_algorithm),"Total_Fractional_Step")==0)
    ALGORITHM:            Fractional_step, Total  
*elseif(strcasecmp(GenData(NSTINC_algorithm),"Three_Field")==0)
    ALGORITHM:            Three
*elseif(strcasecmp(GenData(NSTINC_algorithm),"Three_Field_Pressure_Correction")==0)
    ALGORITHM:            Fvisc
*elseif(strcasecmp(GenData(NSTINC_algorithm),"Incremental_Fractional_Step")==0)
    ALGORITHM:            Fractional_step, Incremental
*elseif(strcasecmp(GenData(NSTINC_algorithm),"Velocity_Correction")==0)
    ALGORITHM:            Velocity_Correction
*elseif(strcasecmp(GenData(NSTINC_algorithm),"Pressure_Correction")==0)
    ALGORITHM:            Pressure_Correction
*endif 
*if(strcasecmp(GenData(NSTINC_convergence),"Required")==0)
    CONVERGENCE_REQUIRED: Yes
*else
    CONVERGENCE_REQUIRED: No
*endif
*if(strcasecmp(GenData(NSTINC_External_Temperature),"Off")==0)
    EXTERNAL TEMPERATURE: Off
*else    
    EXTERNAL TEMPERATURE: ON CASE: *GenData(NSTINC_couple_with) MODNAME: *GenData(NSTINC_External_Temperature)
*endif
*if(strcasecmp(GenData(NSTINC_External_LevelSet),"Off")==0)    
    EXTERNAL LEVELSET:    Off
*else	
*# EXTERNAL LEVELSET:    ON CASE: *GenData(NSTINC_couple_with)  MODNAME: *GenData(NSTINC_External_LevelSet)
    EXTERNAL LEVELSET:    ON CASE: SELF  MODNAME: *GenData(NSTINC_External_LevelSet)		
*endif
*if(strcasecmp(GenData(NSTINC_Dirichlet_VELOC),"Off")==0)    
    EXTERNAL DIRVELOC:    Off
*else    
    EXTERNAL DIRVELOC:    ON CASE: *GenData(NSTINC_DirVEL_FromCase) ModName: *GenData(NSTINC_Dirichlet_VELOC) 
*endif
*if(strcasecmp(GenData(NSTINC_External_Lighthill),"Off")==0)  
    EXTERNAL LIGHTHILL:   OFF
*else
    EXTERNAL LIGHTHILL:   ON CASE: *GenData(NSTINC_couple_with) MODNAME: *GenData(NSTINC_External_Lighthill)
*endif    
*if(strcasecmp(GenData(NSTINC_case_coupling),"On")==0)
    EXTERNAL SOLID:       ON  CASE: *GenData(NSTINC_couple_with) MODNAME: *GenData(NSTINC_External_Solid)
*endif
*if(strcasecmp(GenData(NSTINC_do_ROM),"Yes")==0)
REDUCED_ORDER_PROBLEM
$------------------------------------------------------------ 
    STAGE:                         *GenData(NSTINC_PODROM_Task)
    MASS_PROJECTION:               *GenData(NSTINC_PODROM_Masspro)
    STYPE_OF_ROM:                  *GenData(NSTINC_PODROM_Solver)
    NSNAPSHOTS:                    *GenData(NSTINC_PODROM_snapshots)
    INTERVAL_BETWEEN_SNAPSHOTS:    *GenData(NSTINC_PODROM_snapshot_interval)
    NON_LINEAR_ITERATIONS:         *GenData(NSTINC_PODROM_non_linear_iterations)
    CONVERGENCE_TOLERANCE:         *GenData(NSTINC_PODROM_convergence_tolerance)
    ENERGY_RETAINED:               *GenData(NSTINC_PODROM_retained_energy)
    PROJECTION_SPACE:              *GenData(NSTINC_PODROM_sampling_space)
    MEAN_SUBSTRACTION:             *GenData(NSTINC_PODROM_mean_substraction)
    SUBSCALES_FOR_ROM:             *GenData(NSTINC_PODROM_do_subscales) 
#ROM_SOLVER_OPTIONS
-nsi_ksp_type bcgs                                   
-nsi_ksp_rtol 1e-8                                   
-nsi_pc_type asm    
-nsi_pc_asm_overlap 3                                
-nsi_mat_type mpibaij                                
-nsi_ksp_pc_side right                               
-nsi_sub_pc_type ilu                                 
-nsi_sub_pc_factor_mat_ordering rcm                  
-nsi_sub_pc_factor_levels 10                         
-nsi_svd_tol 1e-8
-nsi_svd_max_it 1000
-nsi_svd_type trlanczos                              
-nsi_svd_nsv 100
-nsi_bv_type vecs 
#END_ROM_SOLVER_OPTIONS
$------------------------------------------------------------ 
END_REDUCED_ORDER_PROBLEM
*endif
*\*if(strcasecmp(GenData(NSTINC_do_Interpolate),"Yes")==0)
*\    INTERPOLATION_DATA
*\   FROM_CASE: *GenData(NSTINC_couple_with)  *GenData(NSTINC_Interpolation_type)  *GenData(NSTINC_Interpolation_Body)
*\    END_INTERPOLATION_DATA
*\*endif
  END_NSTINC_PROBLEM
*if(strcasecmp(GenData(NSTINC_do_ROM),"Yes")==0)
  END_PODROM_NSTINC_PROBLEM
*endif

*endif
*\
*\ TEMPER ----------------------------------------------------------
*\ 
*if(strcasecmp(GenData(TEMPER_problem),"Off")!=0)
*if(strcasecmp(GenData(TEMPER_do_ROM),"Yes")==0)
  PODROM_TEMPER_PROBLEM:         On MODNAME: *GenData(TEMPER_module_nickname)
    DELAY_STEPS:          *GenData(TEMPER_PODROM_Delay_Steps)
    RESTART:              *GenData(TEMPER_Restart)
*if(strcasecmp(GenData(TEMPER_Restart),"Interpolated")==0)
    OLD_CASE_NAME:      *GenData(TEMPER_Old_case_name)
*endif
    PHYSICAL_PROBLEM:     Temperature
*endif
  TEMPER_PROBLEM:         *GenData(TEMPER_problem)  MODNAME: *GenData(TEMPER_module_nickname)
    DELAY_STEPS:          *GenData(TEMPER_Delay_Steps)
    PRELIMINARY_RUN:      *GenData(TEMPER_Preliminary_run) FREQUENCY=*GenData(TEMPER_Preliminary_output_frequency)
    RESTART:              *GenData(TEMPER_Restart)
*if(strcasecmp(GenData(TEMPER_Restart),"Interpolated")==0)
    OLD_CASE_NAME:      *GenData(TEMPER_Old_case_name)
*endif
*if(strcasecmp(GenData(TEMPER_convergence),"Required")==0)
    CONVERGENCE_REQUIRED: Yes
*else
    CONVERGENCE_REQUIRED: No
*endif
*if(strcasecmp(GenData(TEMPER_External_Velocity),"Off")!=0)
    EXTERNAL VELOCITY:    ON CASE: *GenData(TEMPER_couple_with) MODNAME: *GenData(TEMPER_External_Velocity)
*endif
*if(strcasecmp(GenData(TEMPER_External_SEA),"Off")!=0)
    EXTERNAL SELECTIVE:   ON CASE: SELF MODNAME: *GenData(TEMPER_External_SEA)
*endif
*if(strcasecmp(GenData(TEMPER_do_ROM),"Yes")==0)
REDUCED_ORDER_PROBLEM
$------------------------------------------------------------ 
    STAGE:                         *GenData(TEMPER_PODROM_Task)
    MASS_PROJECTION:               *GenData(TEMPER_PODROM_Masspro)
    STYPE_OF_ROM:                  *GenData(TEMPER_PODROM_Solver)
    NSNAPSHOTS:                    *GenData(TEMPER_PODROM_snapshots)
    INTERVAL_BETWEEN_SNAPSHOTS:    *GenData(TEMPER_PODROM_snapshot_interval)
    NON_LINEAR_ITERATIONS:         *GenData(TEMPER_PODROM_non_linear_iterations)
    CONVERGENCE_TOLERANCE:         *GenData(TEMPER_PODROM_convergence_tolerance)
    ENERGY_RETAINED:               *GenData(TEMPER_PODROM_retained_energy)
    PROJECTION_SPACE:              *GenData(TEMPER_PODROM_sampling_space)
    MEAN_SUBSTRACTION:             *GenData(TEMPER_PODROM_mean_substraction)
    SUBSCALES_FOR_ROM:             *GenData(TEMPER_PODROM_do_subscales) 
#ROM_SOLVER_OPTIONS
-tem_ksp_type bcgs                                   
-tem_ksp_rtol 1e-8                                   
-tem_pc_type asm    
-tem_pc_asm_overlap 3                                
-tem_mat_type mpibaij                                
-tem_ksp_pc_side right                               
-tem_sub_pc_type ilu                                 
-tem_sub_pc_factor_mat_ordering rcm                  
-tem_sub_pc_factor_levels 10                         
-tem_svd_tol 1e-8
-tem_svd_max_it 1000
-tem_svd_type trlanczos                              
-tem_svd_nsv 100
-tem_bv_type vecs 
#END_ROM_SOLVER_OPTIONS
$------------------------------------------------------------ 
END_REDUCED_ORDER_PROBLEM
*endif

  END_TEMPER_PROBLEM
*if(strcasecmp(GenData(TEMPER_do_ROM),"Yes")==0)
END_PODROM_TEMPER_PROBLEM
*endif

*endif
*\
*\ NSTPRI ----------------------------------------------------------
*\ 
*if(strcasecmp(GenData(NSTPRI_problem),"Off")!=0)
  NSTPRI_PROBLEM:         *GenData(NSTPRI_problem)  MODNAME: *GenData(NSTPRI_module_nickname)
  DELAY_STEPS:          *GenData(NSTPRI_Delay_Steps)
  PRELIMINARY_RUN:      *GenData(NSTPRI_Preliminary_run) FREQUENCY=*GenData(NSTPRI_Preliminary_output_frequency)
  RESTART:              *GenData(NSTPRI_Restart)
*if(strcasecmp(GenData(NSTPRI_Algorithm),"Monolithic")==0)
    ALGORITHM:            Monolithic
*elseif(strcasecmp(GenData(NSTPRI_Algorithm),"Fractional_Step")==0)
    ALGORITHM:            Fractional
*endif 
  END_NSTPRI_PROBLEM
*endif
*\
*\ OPTICS ----------------------------------------------------------
*\ 
*if(strcasecmp(GenData(OPTICS_problem),"Off")!=0)
  OPTICS_PROBLEM:         *GenData(OPTICS_problem)
    DELAY_STEPS:          *GenData(OPTICS_Delay_Steps)
    PRELIMINARY_RUN:      *GenData(OPTICS_Preliminary_run) FREQUENCY=*GenData(OPTICS_Preliminary_output_frequency)
    RESTART:              *GenData(OPTICS_Restart)
*if(strcasecmp(GenData(OPTICS_Restart),"Interpolated")==0)
    OLD_CASE_NAME:      *GenData(OPTICS_Old_case_name)
*endif
    EXTERNAL VELOCITY:  ON CASE SELF MODNAME *GenData(OPTICS_External_Velocity)
    EXTERNAL TEMPERATURE: ON CASE SELF MODNAME   *GenData(OPTICS_External_Temperature)
  END_OPTICS_PROBLEM
  
*endif
*\
*\ NSCOMP ----------------------------------------------------------
*\ 
*if(strcasecmp(GenData(NSCOMP_problem),"Off")!=0)
*if(strcasecmp(GenData(NSCOMP_do_ROM),"Yes")==0)
  PODROM_NSCOMP_PROBLEM:         On MODNAME: *GenData(NSCOMP_module_nickname)
    DELAY_STEPS:          *GenData(NSCOMP_PODROM_Delay_Steps)
    RESTART:              *GenData(NSCOMP_Restart)
*if(strcasecmp(GenData(NSCOMP_Restart),"Interpolated")==0)
    OLD_CASE_NAME:      *GenData(NSCOMP_Old_case_name)
*endif
    PHYSICAL_PROBLEM:     Compressible
*endif
  NSCOMP_PROBLEM:         *GenData(NSCOMP_problem)  MODNAME: *GenData(NSCOMP_module_nickname)
  DELAY_STEPS:          *GenData(NSCOMP_Delay_Steps)
  PRELIMINARY_RUN:      *GenData(NSCOMP_Preliminary_run) FREQUENCY=*GenData(NSCOMP_Preliminary_output_frequency)
  RESTART:              *GenData(NSCOMP_Restart)
*if(strcasecmp(GenData(NSCOMP_Restart),"Interpolated")==0)
    OLD_CASE_NAME:      *GenData(NSCOMP_Old_case_name)
*endif
*if(strcasecmp(GenData(NSCOMP_algorithm),"Explicit")==0)
    ALGORITHM:            Explicit   
*elseif(strcasecmp(GenData(NSCOMP_algorithm),"Implicit")==0)
    ALGORITHM:            Implicit  
*elseif(strcasecmp(GenData(NSCOMP_algorithm),"Primitive")==0)
    ALGORITHM:            Primitive  
*elseif(strcasecmp(GenData(NSCOMP_algorithm),"Primitive_Simplified")==0)
    ALGORITHM:            Simplified_Primitive  
*elseif(strcasecmp(GenData(NSCOMP_algorithm),"Primitive_Fractional_Step")==0)
    ALGORITHM:            FS_Primitive
*endif 
*if(strcasecmp(GenData(NSCOMP_convergence),"Required")==0)
    CONVERGENCE_REQUIRED: Yes
*else
    CONVERGENCE_REQUIRED: No
*endif
*if(strcasecmp(GenData(NSCOMP_External_Mesh),"ALEmov")==0)
    EXTERNAL ALEMOV:  ON CASE: SELF MODNAME:     ALEMOV 
*endif
*if(strcasecmp(GenData(NSCOMP_do_ROM),"Yes")==0)
REDUCED_ORDER_PROBLEM
$------------------------------------------------------------ 
    STAGE:                         *GenData(NSCOMP_PODROM_Task)
    MASS_PROJECTION:               *GenData(NSCOMP_PODROM_Masspro)
    STYPE_OF_ROM:                  *GenData(NSCOMP_PODROM_Solver)
    NSNAPSHOTS:                    *GenData(NSCOMP_PODROM_snapshots)
    INTERVAL_BETWEEN_SNAPSHOTS:    *GenData(NSCOMP_PODROM_snapshot_interval)
    NON_LINEAR_ITERATIONS:         *GenData(NSCOMP_PODROM_non_linear_iterations)
    CONVERGENCE_TOLERANCE:         *GenData(NSCOMP_PODROM_convergence_tolerance)
    ENERGY_RETAINED:               *GenData(NSCOMP_PODROM_retained_energy)
    PROJECTION_SPACE:              *GenData(NSCOMP_PODROM_sampling_space)
    MEAN_SUBSTRACTION:             *GenData(NSCOMP_PODROM_mean_substraction)
    SUBSCALES_FOR_ROM:             *GenData(NSCOMP_PODROM_do_subscales) 
#ROM_SOLVER_OPTIONS
-nsc_ksp_type bcgs                                   
-nsc_ksp_rtol 1e-8                                   
-nsc_pc_type asm    
-nsc_pc_asm_overlap 3                                
-nsc_mat_type mpibaij                                
-nsc_ksp_pc_side right                               
-nsc_sub_pc_type ilu                                 
-nsc_sub_pc_factor_mat_ordering rcm                  
-nsc_sub_pc_factor_levels 10                         
-nsc_svd_tol 1e-8
-nsc_svd_max_it 1000
-nsc_svd_type trlanczos                              
-nsc_svd_nsv 100
-nsc_bv_type vecs 
#END_ROM_SOLVER_OPTIONS
$------------------------------------------------------------ 
END_REDUCED_ORDER_PROBLEM
*endif
  END_NSCOMP_PROBLEM
*if(strcasecmp(GenData(NSCOMP_do_ROM),"Yes")==0)
END_PODROM_NSCOMP_PROBLEM
*endif
*endif
*\
*\ LMACHN ----------------------------------------------------------
*\
*if(strcasecmp(GenData(LMACHN_problem),"Off")!=0)
*if(strcasecmp(GenData(LMACHN_do_ROM),"Yes")==0)
  PODROM_LMACHN_PROBLEM:         On MODNAME: *GenData(LMACHN_module_nickname)
    DELAY_STEPS:          *GenData(LMACHN_PODROM_Delay_Steps)
    RESTART:              *GenData(LMACHN_Restart)
*if(strcasecmp(GenData(LMACHN_Restart),"Interpolated")==0)
    OLD_CASE_NAME:      *GenData(LMACHN_Old_case_name)
*endif
    PHYSICAL_PROBLEM:     LowMach
*endif
  LMACHN_PROBLEM:         *GenData(LMACHN_problem)  MODNAME: *GenData(LMACHN_module_nickname) 
    DELAY_STEPS:          *GenData(LMACHN_Delay_Steps)
    PRELIMINARY_RUN:      *GenData(LMACHN_Preliminary_run) FREQUENCY=*GenData(LMACHN_Preliminary_output_frequency)
    RESTART:              *GenData(LMACHN_Restart)
*if(strcasecmp(GenData(LMACHN_Restart),"Interpolated")==0)
    OLD_CASE_NAME:      *GenData(LMACHN_Old_case_name)
*endif
*if(strcasecmp(GenData(LMACHN_convergence),"Required")==0)
    CONVERGENCE_REQUIRED: Yes
*else
    CONVERGENCE_REQUIRED: No
*endif
*if(strcasecmp(GenData(LMACHN_do_ROM),"Yes")==0)
REDUCED_ORDER_PROBLEM
$------------------------------------------------------------ 
    STAGE:                         *GenData(LMACHN_PODROM_Task)
    MASS_PROJECTION:               *GenData(LMACHN_PODROM_Masspro)
    STYPE_OF_ROM:                  *GenData(LMACHN_PODROM_Solver)
    NSNAPSHOTS:                    *GenData(LMACHN_PODROM_snapshots)
    INTERVAL_BETWEEN_SNAPSHOTS:    *GenData(LMACHN_PODROM_snapshot_interval)
    NON_LINEAR_ITERATIONS:         *GenData(LMACHN_PODROM_non_linear_iterations)
    CONVERGENCE_TOLERANCE:         *GenData(LMACHN_PODROM_convergence_tolerance)
    ENERGY_RETAINED:               *GenData(LMACHN_PODROM_retained_energy)
    PROJECTION_SPACE:              *GenData(LMACHN_PODROM_sampling_space)
    MEAN_SUBSTRACTION:             *GenData(LMACHN_PODROM_mean_substraction)
    SUBSCALES_FOR_ROM:             *GenData(LMACHN_PODROM_do_subscales) 
#ROM_SOLVER_OPTIONS
-lmn_ksp_type bcgs                                   
-lmn_ksp_rtol 1e-8                                   
-lmn_pc_type asm    
-lmn_pc_asm_overlap 3                                
-lmn_mat_type mpibaij                                
-lmn_ksp_pc_side right                               
-lmn_sub_pc_type ilu                                 
-lmn_sub_pc_factor_mat_ordering rcm                  
-lmn_sub_pc_factor_levels 10                         
-lmn_svd_tol 1e-8
-lmn_svd_max_it 1000
-lmn_svd_type trlanczos                              
-lmn_svd_nsv 100
-lmn_bv_type vecs 
#END_ROM_SOLVER_OPTIONS
$------------------------------------------------------------ 
END_REDUCED_ORDER_PROBLEM
*endif
END_LMACHN_PROBLEM
*if(strcasecmp(GenData(LMACHN_do_ROM),"Yes")==0)
END_PODROM_LMACHN_PROBLEM
*endif

*endif
*\
*\ SOLIDS ----------------------------------------------------------
*\
*if(strcasecmp(GenData(SOLIDS_problem),"Off")!=0)
*if(strcasecmp(GenData(SOLIDS_do_ROM),"Yes")==0)
  PODROM_SOLIDS_PROBLEM:         On MODNAME: *GenData(SOLIDS_module_nickname)
    DELAY_STEPS:          *GenData(SOLIDS_PODROM_Delay_Steps)
    RESTART:              *GenData(SOLIDS_Restart) $Initial, Interpolated
*if(strcasecmp(GenData(SOLIDS_Restart),"Interpolated")==0)
    OLD_CASE_NAME:      *GenData(SOLIDS_Old_case_name)
*endif
    PHYSICAL_PROBLEM:     Solids
*endif
  SOLIDS_PROBLEM:         *GenData(SOLIDS_problem) MODNAME: *GenData(SOLIDS_module_nickname)
    DELAY_STEPS:          *GenData(SOLIDS_Delay_Steps)
    PRELIMINARY_RUN:      *GenData(SOLIDS_Preliminary_run) FREQUENCY=*GenData(SOLIDS_Preliminary_output_frequency)
    RESTART:              *GenData(SOLIDS_Restart) $Initial,Interpolated
*if(strcasecmp(GenData(SOLIDS_Restart),"Interpolated")==0)
    OLD_CASE_NAME:      *GenData(SOLIDS_Old_case_name)
*endif
*if(strcasecmp(GenData(SOLIDS_convergence),"Required")==0)
    CONVERGENCE_REQUIRED: Yes
*else
    CONVERGENCE_REQUIRED: No
*endif
*if(strcasecmp(GenData(SOLIDS_case_coupling),"On")==0)
    EXTERNAL FLUID:       ON CASE: *GenData(SOLIDS_couple_with) MODNAME:  *GenData(SOLIDS_case_coupling)
*endif
*if(strcasecmp(GenData(SOLIDS_External_ALE),"On")==0)
    EXTERNAL ALEMOV:  ON     CASE: *GenData(SOLIDS_couple_with) MODNAME: *GenData(SOLIDS_External_ALE)
*endif
*if(strcasecmp(GenData(SOLIDS_do_ROM),"Yes")==0)
REDUCED_ORDER_PROBLEM
$------------------------------------------------------------ 
    STAGE:                         *GenData(SOLIDS_PODROM_Task)
    MASS_PROJECTION:               *GenData(SOLIDS_PODROM_Masspro)
    STYPE_OF_ROM:                  *GenData(SOLIDS_PODROM_Solver)
    NSNAPSHOTS:                    *GenData(SOLIDS_PODROM_snapshots)
    INTERVAL_BETWEEN_SNAPSHOTS:    *GenData(SOLIDS_PODROM_snapshot_interval)
    NON_LINEAR_ITERATIONS:         *GenData(SOLIDS_PODROM_non_linear_iterations)
    CONVERGENCE_TOLERANCE:         *GenData(SOLIDS_PODROM_convergence_tolerance)
    ENERGY_RETAINED:               *GenData(SOLIDS_PODROM_retained_energy)
    PROJECTION_SPACE:              *GenData(SOLIDS_PODROM_sampling_space)
    MEAN_SUBSTRACTION:             *GenData(SOLIDS_PODROM_mean_substraction)
    SUBSCALES_FOR_ROM:             *GenData(SOLIDS_PODROM_do_subscales) 
#ROM_SOLVER_OPTIONS
-sld_ksp_type bcgs                                   
-sld_ksp_rtol 1e-8                                   
-sld_pc_type asm    
-sld_pc_asm_overlap 3                                
-sld_mat_type mpibaij                                
-sld_ksp_pc_side right                               
-sld_sub_pc_type ilu                                 
-sld_sub_pc_factor_mat_ordering rcm                  
-sld_sub_pc_factor_levels 10                         
-sld_svd_tol 1e-8
-sld_svd_max_it 1000
-sld_svd_type trlanczos                              
-sld_svd_nsv 100
-sld_bv_type vecs 
#END_ROM_SOLVER_OPTIONS
$------------------------------------------------------------ 
END_REDUCED_ORDER_PROBLEM
*endif
END_SOLIDS_PROBLEM
*if(strcasecmp(GenData(SOLIDS_do_ROM),"Yes")==0)
END_PODROM_SOLIDS_PROBLEM
*endif

*endif
*\
*\ ALEMOV ----------------------------------------------------------
*\ 
*if(strcasecmp(GenData(ALEMOV_problem),"Off")!=0)
  ALE_PROBLEM:         *GenData(ALEMOV_problem)
    DELAY_STEPS:          *GenData(ALEMOV_Delay_Steps)
    PRELIMINARY_RUN:      *GenData(ALEMOV_Preliminary_run) FREQUENCY=*GenData(ALEMOV_Preliminary_output_frequency)
    RESTART:              *GenData(ALEMOV_Restart) $Initial, Interpolated  
*if(strcasecmp(GenData(ALEMOV_Restart),"Interpolated")==0)
    OLD_CASE_NAME:      *GenData(ALEMOV_Old_case_name)
*endif
*if(strcasecmp(GenData(ALEMOV_algorithm),"Solid")==0)
    ALGORITHM:            SOLID_BODY
*else
    ALGORITHM:            POISSON
*endif
*if(strcasecmp(GenData(ALEMOV_convergence),"Required")==0)
    CONVERGENCE_REQUIRED: Yes
*else
    CONVERGENCE_REQUIRED: No
*endif
*if(strcasecmp(GenData(ALEMOV_External_Fluid),"Off")!=0)
 EXTERNAL FLUID:    ON CASE: SELF MODNAME:   *GenData(ALEMOV_External_Fluid)
*endif 
*if(strcasecmp(GenData(ALEMOV_External_Solid),"Off")!=0)
 EXTERNAL SOLID:    ON CASE: *GenData(ALEMOV_couple_with) MODNAME:    *GenData(ALEMOV_External_Solid)
*endif 
*if(strcasecmp(GenData(ALEMOV_External_Fluid),"Nscomp")==0)
    CONSECUTIVE_DELAY:    *GenData(ALEMOV_Consecutive_Delay)
*endif
*if(strcasecmp(GenData(ALEMOV_FixedMesh_From),"Off")!=0)
    FIXED MESH  :   ON CASE: SELF MODNAME *GenData(ALEMOV_FixedMesh_From)
*endif    
  END_ALE_PROBLEM
  
*endif
*\
*\ WAVETM ----------------------------------------------------------
*\
*if(strcasecmp(GenData(WAVETM_problem),"Off")!=0)
  WAVTM_PROBLEM:         *GenData(WAVETM_problem)
    DELAY_STEPS:          *GenData(WAVETM_Delay_Steps)
    PRELIMINARY_RUN:      *GenData(WAVETM_Preliminary_run) FREQUENCY=*GenData(WAVETM_Preliminary_output_frequency)
    RESTART:              *GenData(WAVETM_Restart)
*if(strcasecmp(GenData(WAVETM_Restart),"Interpolated")==0)
    OLD_CASE_NAME:      *GenData(WAVETM_Old_case_name)
*endif
*if(strcasecmp(GenData(WAVETM_External_Source),"Off")!=0)
    EXTERNAL FLUID:  ON CASE: SELF MODNAME: NSTINC  *GenData(WAVETM_External_Source)
*endif
*if(strcasecmp(GenData(WAVETM_convergence),"Required")==0)
    CONVERGENCE_REQUIRED: Yes
*else
    CONVERGENCE_REQUIRED: No
*endif
  END_WAVTM_PROBLEM
  
*endif
*\
*\ WAVETI ----------------------------------------------------------
*\ 
*if(strcasecmp(GenData(WAVTI_problem),"Off")!=0)
  WAVTI_PROBLEM:          *GenData(WAVTI_problem)
    DELAY_STEPS:          *GenData(WAVTI_Delay_Steps)
    PRELIMINARY_RUN:      *GenData(WAVTI_Preliminary_run) FREQUENCY=*GenData(WAVTI_Preliminary_output_frequency)
    RESTART:              *GenData(WAVTI_Restart)
*if(strcasecmp(GenData(WAVTI_Restart),"Interpolated")==0)
    OLD_CASE_NAME:      *GenData(WAVTI_Old_case_name)
*endif
*if(strcasecmp(GenData(WAVTI_External_Source),"Off")!=0)
    EXTERNAL FLUID: ON CASE: SELF MODNAME: NSTINC *GenData(WAVTI_External_Source)
*endif    
*if(strcasecmp(GenData(WAVTI_convergence),"Required")==0)
    CONVERGENCE_REQUIRED: Yes
*else
    CONVERGENCE_REQUIRED: No
*endif
*if(strcasecmp(GenData(WAVTI_Decomposition),"Yes")==0)
    Decomposition: Yes
*else
    Decomposition: No
*endif
  END_WAVTI_PROBLEM
*endif
*\
*\ HELMHZ ----------------------------------------------------------
*\ 
*if(strcasecmp(GenData(HELMHZ_problem),"Off")!=0)
  HELMHZ_PROBLEM:         *GenData(HELMHZ_problem)
*if(strcasecmp(GenData(HELMHZ_Equation_form),"Scalar")==0)
    EQUATION_FORM:            Scalar  
*elseif(strcasecmp(GenData(HELMHZ_Equation_form),"Mixed")==0)
    EQUATION_FORM:            Mixed
*endif
*if(strcasecmp(GenData(HELMHZ_External_Source),"Off")!=0)
  EXTERNAL FLUID: ON CASE: SELF MODNAME: NSTINC *GenData(HELMHZ_External_Source)
*endif 
  END_HELMHZ_PROBLEM
*endif

*\
*\ INTERP ----------------------------------------------------------
*\ 
*if(strcasecmp(GenData(INTERP_problem),"Off")!=0)
  INTERP_PROBLEM:         *GenData(INTERP_problem)
    DELAY_STEPS:          *GenData(INTERP_Delay_Steps)
  END_INTERP_PROBLEM
  
*endif
*\
*\ LEVSET ----------------------------------------------------------
*\ 
*if(strcasecmp(GenData(LEVSET_problem),"Off")!=0)
  LEVSET_PROBLEM:         *GenData(LEVSET_problem)
    DELAY_STEPS:          *GenData(LEVSET_Delay_Steps)
    PRELIMINARY_RUN:      *GenData(LEVSET_Preliminary_run) FREQUENCY=*GenData(LEVSET_Preliminary_output_frequency)
    RESTART:              *GenData(LEVSET_Restart)
*if(strcasecmp(GenData(LEVSET_Restart),"Interpolated")==0)
    OLD_CASE_NAME:      *GenData(LEVSET_Old_case_name)
*endif
*if(strcasecmp(GenData(LEVSET_convergence),"Required")==0)
    CONVERGENCE_REQUIRED: Yes
*else
    CONVERGENCE_REQUIRED: No
*endif
*if(strcasecmp(GenData(LEVSET_External_Velocity),"Off")!=0)
    EXTERNAL VELOCITY:  ON CASE: SELF MODNAME: *GenData(LEVSET_External_Velocity)
*endif
*if(strcasecmp(GenData(LEVSET_External_LEVSET),"Off") != 0)    
    EXTERNAL LEVSET:   ON  Case: *GenData(LEVSET_ExtLEVSET_FromCase) ModName: *GenData(LEVSET_External_LEVSET)
*endif    
  END_LEVSET_PROBLEM
  
*endif
*\
*\ MAXWEL ----------------------------------------------------------
*\
*if(strcasecmp(GenData(MAXWEL_problem),"Off")!=0)
MAXWEL_PROBLEM: *GenData(MAXWEL_problem)
    DELAY_STEPS: *GenData(MAXWEL_Delay_Steps)
    PRELIMINARY_RUN:      *GenData(MAXWEL_Preliminary_run) FREQUENCY=*GenData(MAXWEL_Preliminary_output_frequency)
    RESTART:              *GenData(MAXWEL_Restart)
*if(strcasecmp(GenData(MAXWEL_Restart),"Interpolated")==0)
    OLD_CASE_NAME:      *GenData(MAXWEL_Old_case_name)
*endif
*if(strcasecmp(GenData(MAXWEL_convergence),"Required")==0)
CONVERGENCE_REQUIRED: Yes
*else
CONVERGENCE_REQUIRED: No
*endif
END_MAXWEL_PROBLEM

*endif
*\
*\ PLCd ----------------------------------------------------------
*\
*if(strcasecmp(GenData(PLCd_problem),"Off")!=0)
  PLCD_PROBLEM:            *GenData(PLCd_problem)
    DELAY_STEPS:           *GenData(PLCd_Delay_Steps)
    PRELIMINARY_RUN:       *GenData(PLCd_Preliminary_run) FREQUENCY=*GenData(PLCd_Preliminary_output_frequency)
    RESTART:               *GenData(PLCd_Restart)
*if(strcasecmp(GenData(PLCd_Restart),"Interpolated")==0)
    OLD_CASE_NAME:         *GenData(PLCd_Old_case_name)
*endif
*if(strcasecmp(GenData(PLCd_convergence),"Required")==0)
    CONVERGENCE_REQUIRED:  Yes
*else
    CONVERGENCE_REQUIRED:  No
*endif
*if(strcasecmp(GenData(PLCd_External_Fluid),"Off")!=0)
    EXTERNAL FLUID:       ON CASE: *GenData(PLCd_couple_with) MODNAME: *GenData(PLCd_External_Fluid)
*endif
*if(strcasecmp(GenData(PLCd_External_TEMPE),"Off")!=0)
    EXTERNAL TEMPE:       ON  CASE: *GenData(PLCd_couple_with) MODNAME: *GenData(PLCd_External_TEMPE)
*endif
*if(strcasecmp(GenData(PLCd_External_SEA),"Off")!=0)
    EXTERNAL SELECTIVE:   ON  CASE: *GenData(PLCd_couple_with) MODNAME: *GenData(PLCd_External_SEA)
*endif
  END_PLCD_PROBLEM
  
*endif
*\
*\ SEA ----------------------------------------------------------
*\
*if(strcasecmp(GenData(ADDITIVE_problem),"Off")!=0)
  SEA_PROBLEM:            *GenData(ADDITIVE_problem)
    DELAY_STEPS:          *GenData(SEA_Delay_Steps)
  END_SEA_PROBLEM
  
*endif


*\
*\ BEAM ----------------------------------------------------------
*\
*if(strcasecmp(GenData(BEAM_problem),"Off")!=0)

 BEAM_PROBLEM:           *GenData(BEAM_problem)
   DELAY_STEPS:          *GenData(BEAM_Delay_Steps)
   PRELIMINARY_RUN:      *GenData(NSCOMP_Preliminary_run)
   FREQUENCY=*GenData(BEAM_Preliminary_output_frequency)
   RESTART:              *GenData(BEAM_Restart) $Initial, Interpolated  
*if(strcasecmp(GenData(BEAM_Restart),"Interpolated")==0)
    OLD_CASE_NAME:      *GenData(BEAM_Old_case_name)
*endif
*\*if(strcasecmp(GenData(BEAM_convergence),"Required")==0)
*\   CONVERGENCE_REQUIRED: Yes
*\*else
*\   CONVERGENCE_REQUIRED: No
*\*endif
 END_BEAM_PROBLEM
*endif
*\
*\ PLATE ----------------------------------------------------------
*\
*if(strcasecmp(GenData(PLAT_problem),"Off")!=0)
  PLAT_PROBLEM:            *GenData(PLAT_problem)
    DELAY_STEPS:          *GenData(PLAT_Delay_Steps)
    PRELIMINARY_RUN:      *GenData(NSCOMP_Preliminary_run)
    FREQUENCY=*GenData(PLAT_Preliminary_output_frequency)
    RESTART:              *GenData(PLAT_Restart) $Initial, Interpolated  
*if(strcasecmp(GenData(PLAT_Restart),"Interpolated")==0)
    OLD_CASE_NAME:      *GenData(PLAT_Old_case_name)
*endif
*\if(strcasecmp(GenData(PLAT_convergence),"Required")==0)
*\  CONVERGENCE_REQUIRED: Yes
*\else
*\  CONVERGENCE_REQUIRED: No
*\endif
  END_PLAT_PROBLEM
*endif
  
END_PROBLEM_DATA
$-------------------------------------------------------------------
INTERPOLATION_DATA
*if(strcasecmp(GenData(INTERP1_Case),"None")!=0)
   FROM_CASE: *GenData(INTERP1_Case) *GenData(INTERP1_Interpolation_type) *GenData(INTERP1_Interpolation_Body) *GenData(INTERP1_ALE_INTERPOLATION)
*else
*endif
*if(strcasecmp(GenData(INTERP2_Case),"None")!=0)
   FROM_CASE: *GenData(INTERP2_Case) *GenData(INTERP2_Interpolation_type) *GenData(INTERP2_Interpolation_Body) *GenData(INTERP2_ALE_INTERPOLATION)
*endif  
END_INTERPOLATION_DATA
$-------------------------------------------------------------------
