#########################################################################
#
#  tcl main file for the problem type Femuss
#
########################################################################
proc InitGIDProject  { dir } {
    global Femuss
    global Text

    FemussGetPaths
    set Femuss(ptypepath) $dir
    HideModules
}

proc EndGIDProject { } {
    global Femuss
}

proc LoadGIDProject { filespd } {
    global Femuss
    HideModules
}

proc InitGIDPostProcess { } {
    global Femuss
}

proc AfterWriteCalcFileGIDProject { file error } {
}


proc EndGIDPostProcess { } {  
    global Femuss
}


proc FemussGetPaths { } {
    global Femuss
    set Femuss(projectpath) [.central.s info Project]
    set Femuss(projectpath) [lindex $Femuss(projectpath) 1]
    set lname               [split  $Femuss(projectpath) \\] 
    set Femuss(projectname) [lindex $lname [expr {[llength $lname]-1}]]
    set Femuss(projectpath) [join   $lname /]
    set Femuss(resultspath) $Femuss(projectpath).gid/results
    #set Femuss(ptypepath)   [.central.s info problemtypepath]
}


proc BeforeMeshGeneration { elSize } {
    global Femuss
}



proc BeforeWriteCalcFileGIDProject { file } {
    global Femuss
}



proc FemussEvalDirichletCondition { value x y z } {
    set result 0.0
    if { [catch { set result [format "%14.6f" [expr $value]] }]!=0} {
   WarnWinText "Error in Dirichlet boundary conditions!" 
    }
    return $result
}

proc FemussEvalNeumannCondition { value x y z } {
    set result 0.0
    if { [catch { set result [format "%14.6f" [expr $value]] }]!=0} {
   WarnWinText "Error in Neumann boundary conditions!" 
    }
    return $result
}

proc FemussProblemName { } {
    global Femuss
    FemussGetPaths
    set Femuss(projectpath) [.central.s info Project]
    set Femuss(projectpath) [lindex $Femuss(projectpath) 1]
    set lname               [split  $Femuss(projectpath) /] 
    set Femuss(projectname) [lindex $lname [expr {[llength $lname]-1}]]
    #return [file join "data" $Femuss(projectname)]
    #puts $Femuss(projectpath)
    #puts $Femuss(projectname)
    #puts $lname
    #puts $Project
    return $Femuss(projectname)

}

proc MODULES {event args} {
   switch $event {
      INIT {
      }
      SYNC {
        HideModules 
        #GiDMenu::UpdateMenus
      }
      DEPEND{
      }
      CLOSE {
      } 
   }
}




#asdfasdfasdfasdf
proc HideModules { } {
   set isOn [GiD_AccessValue get gendata NSTINC_problem]
   if {$isOn == "Off"} {
      GiD_ShowBook gendata NSTINC 0
      GiD_ShowBook conditions NSTINC_BOUNDARY_CONDITIONS 0
      GiD_ShowBook conditions VISCOELASTIC_BOUNDARY_CONDITIONS 0
   } else {
      GiD_ShowBook gendata NSTINC 1
      GiD_ShowBook conditions NSTINC_BOUNDARY_CONDITIONS 1
      GiD_ShowBook conditions VISCOELASTIC_BOUNDARY_CONDITIONS 1
   }   
   set isOn [GiD_AccessValue get gendata TEMPER_problem]
   if {$isOn == "Off"} {
      GiD_ShowBook gendata TEMPER 0
      GiD_ShowBook conditions TEMPER_BOUNDARY_CONDITIONS 0
      set materialList [GiD_Info materials]
      set theWords [regexp -all -inline {\S+} $materialList]
      foreach i $theWords {
         GiD_AccessValue set material $i TempeVisible NO
      }
   } else {
      GiD_ShowBook gendata TEMPER 1
      GiD_ShowBook conditions TEMPER_BOUNDARY_CONDITIONS 1
      set materialList [GiD_Info materials]
      set theWords [regexp -all -inline {\S+} $materialList]
      foreach i $theWords {
         GiD_AccessValue set material $i TempeVisible YES
      }
   }  
   set isOn [GiD_AccessValue get gendata ADDITIVE_problem]
   if {$isOn == "Off"} {
      GiD_ShowBook gendata ADDITIVE 0
      GiD_ShowBook  intvdata ADDITIVE_Process_Data 0
      set materialList [GiD_Info materials]
      set theWords [regexp -all -inline {\S+} $materialList]
      foreach i $theWords {
         GiD_AccessValue set material $i ADDITIVEVisible NO
      }
   } else {
      GiD_ShowBook gendata ADDITIVE 1
      GiD_ShowBook  intvdata ADDITIVE_Process_Data 1
      set isOnTEMPE [GiD_AccessValue get gendata TEMPER_problem]
      if {$isOnTEMPE == "On"} {
      }
      set materialList [GiD_Info materials]
      set theWords [regexp -all -inline {\S+} $materialList]
      foreach i $theWords {
         GiD_AccessValue set material $i ADDITIVEVisible YES
      }
   }  
   set isOn [GiD_AccessValue get gendata OPTICS_problem]
   if {$isOn == "Off"} {
      GiD_ShowBook gendata OPTICS 0
   } else {
      GiD_ShowBook gendata OPTICS 1
   }      
   set isOn [GiD_AccessValue get gendata NSCOMP_problem]
   if {$isOn == "Off"} {   
      GiD_ShowBook gendata NSCOMP 0
      GiD_ShowBook conditions NSCOMP_BOUNDARY_CONDITIONS 0
   } else {
      GiD_ShowBook gendata NSCOMP 1
      GiD_ShowBook conditions NSCOMP_BOUNDARY_CONDITIONS 1
   }      
   set isOn [GiD_AccessValue get gendata LMACHN_problem]
   if {$isOn == "Off"} {   
      GiD_ShowBook gendata LMACHN 0
      GiD_ShowBook conditions LMACHN_BOUNDARY_CONDITIONS 0
   } else {
      GiD_ShowBook gendata LMACHN 1
      GiD_ShowBook conditions LMACHN_BOUNDARY_CONDITIONS 1
   }      
   set isOn [GiD_AccessValue get gendata NSTPRI_problem]
   if {$isOn == "Off"} {   
      GiD_ShowBook gendata NSTPRI 0
      GiD_ShowBook conditions NSTPRI_BOUNDARY_CONDITIONS 0
   } else {
      GiD_ShowBook gendata NSTPRI 1
      GiD_ShowBook conditions NSTPRI_BOUNDARY_CONDITIONS 1
   }      
   set isOn [GiD_AccessValue get gendata SOLIDS_problem]
   if {$isOn == "Off"} {   
      GiD_ShowBook gendata SOLIDS 0
      GiD_ShowBook conditions SOLIDS_BOUNDARY_CONDITIONS 0
   } else {
      GiD_ShowBook gendata SOLIDS 1
      GiD_ShowBook conditions SOLIDS_BOUNDARY_CONDITIONS 1
   }      
   set isOn [GiD_AccessValue get gendata ALEMOV_problem]
   if {$isOn == "Off"} {   
      GiD_ShowBook gendata ALEMOV 0
      GiD_ShowBook conditions ALEMOV_BOUNDARY_CONDITIONS 0
   } else {
      GiD_ShowBook gendata ALEMOV 1
      GiD_ShowBook conditions ALEMOV_BOUNDARY_CONDITIONS 1
   }      
   set isOn [GiD_AccessValue get gendata INTERP_problem]
   if {$isOn == "Off"} {   
      GiD_ShowBook gendata INTERP 0
      GiD_ShowBook conditions INTERP_BOUNDARY_CONDITIONS 0
   } else {
      GiD_ShowBook gendata INTERP 1
      GiD_ShowBook conditions INTERP_BOUNDARY_CONDITIONS 1
   }      
   set isOn [GiD_AccessValue get gendata WAVTI_problem]
   if {$isOn == "Off"} {   
      GiD_ShowBook gendata WAVETI 0
      GiD_ShowBook conditions WAVETI_BOUNDARY_CONDITIONS 0
   } else {
      GiD_ShowBook gendata WAVETI 1
      GiD_ShowBook conditions WAVETI_BOUNDARY_CONDITIONS 1
   }      
   set isOn [GiD_AccessValue get gendata WAVETM_problem]
   if {$isOn == "Off"} {   
      GiD_ShowBook gendata WAVETM 0
      GiD_ShowBook conditions WAVETM_BOUNDARY_CONDITIONS 0
   } else {
      GiD_ShowBook gendata WAVETM 1
      GiD_ShowBook conditions WAVETM_BOUNDARY_CONDITIONS 1
   }      
   set isOn [GiD_AccessValue get gendata LEVSET_problem]
   if {$isOn == "Off"} {   
      GiD_ShowBook gendata LEVSET 0
      GiD_ShowBook conditions LEVSET_BOUNDARY_CONDITIONS 0
   } else {
      GiD_ShowBook gendata LEVSET 1
      GiD_ShowBook conditions LEVSET_BOUNDARY_CONDITIONS 1
   }      
   set isOn [GiD_AccessValue get gendata MAXWEL_problem]
   if {$isOn == "Off"} {   
      GiD_ShowBook gendata MAXWEL 0
      GiD_ShowBook conditions MAXWEL_BOUNDARY_CONDITIONS 0
   } else {
      GiD_ShowBook gendata MAXWEL 1
      GiD_ShowBook conditions MAXWEL_BOUNDARY_CONDITIONS 1
   }
   set isOn [GiD_AccessValue get gendata HELMHZ_problem]
   if {$isOn == "Off"} {
      GiD_ShowBook gendata HELMHZ 0
      GiD_ShowBook conditions HELMHZ_BOUNDARY_CONDITIONS 0
   } else {
      GiD_ShowBook gendata HELMHZ 1
      GiD_ShowBook conditions HELMHZ_BOUNDARY_CONDITIONS 1
   }        
   set isOn [GiD_AccessValue get gendata PLCd_problem]
   if {$isOn == "Off"} {   
      GiD_ShowBook gendata PLCd 0
      GiD_ShowBook conditions PLCd_BOUNDARY_CONDITIONS 0
      
      set materialList [GiD_Info materials]
      set theWords [regexp -all -inline {\S+} $materialList]
      foreach i $theWords {
         GiD_AccessValue set material $i PLCDVisible NO
         GiD_AccessValue set material $i PLCDbVisible NO
         GiD_AccessValue set material $i PLCDcVisible NO
      }
      
   } else {
      GiD_ShowBook gendata PLCd 1
      GiD_ShowBook conditions PLCd_BOUNDARY_CONDITIONS 1
      
      set materialList [GiD_Info materials]
      set theWords [regexp -all -inline {\S+} $materialList]
      foreach i $theWords {
         GiD_AccessValue set material $i PLCDVisible YES
         set isSIMPLE [GiD_AccessValue get material $i Type_of_Material]
         if {$isSIMPLE == "Simple"} {
            GiD_AccessValue set material $i PLCDbVisible YES
            GiD_AccessValue set material $i PLCDcVisible NO
         } else {
            GiD_AccessValue set material $i PLCDbVisible NO
            GiD_AccessValue set material $i PLCDcVisible YES
         }
      }
   }   
   set isOn [GiD_AccessValue get gendata BEAM_problem]
   if {$isOn == "Off"} {   
      GiD_ShowBook gendata BEAM 0
      GiD_ShowBook conditions BEAM_BOUNDARY_CONDITIONS 0
      set materialList [GiD_Info materials]
      set theWords [regexp -all -inline {\S+} $materialList]
      foreach i $theWords {
         GiD_AccessValue set material $i BeamVisible NO
      }
   } else {
      GiD_ShowBook gendata BEAM 1
      GiD_ShowBook conditions BEAM_BOUNDARY_CONDITIONS 1
      set materialList [GiD_Info materials]
      set theWords [regexp -all -inline {\S+} $materialList]
      foreach i $theWords {
         GiD_AccessValue set material $i BeamVisible YES
      }   
   }
   set isOn [GiD_AccessValue get gendata PLAT_problem]
   if {$isOn == "Off"} {   
      GiD_ShowBook gendata PLAT 0
      GiD_ShowBook conditions PLAT_BOUNDARY_CONDITIONS 0
      set materialList [GiD_Info materials]
      set theWords [regexp -all -inline {\S+} $materialList]
      foreach i $theWords {
         GiD_AccessValue set material $i PLATVisible NO
      }
   } else {
      GiD_ShowBook gendata PLAT 1
      GiD_ShowBook conditions PLAT_BOUNDARY_CONDITIONS 1
      set materialList [GiD_Info materials]
      set theWords [regexp -all -inline {\S+} $materialList]
      foreach i $theWords {
         GiD_AccessValue set material $i PLATVisible YES
      }   
   }
   set isOn [GiD_AccessValue get gendata ADDITIVE_problem]
   if {$isOn == "Off"} {   
      GiD_ShowBook gendata ADDITIVE 0
   } else {
      GiD_ShowBook gendata ADDITIVE 1
   }   
   GiDMenu::UpdateMenus
}

proc FemussWriteTempeDependentProperty { key typeprop value table indent matname} {
   set typeprop [GiD_AccessValue get material $matname $typeprop]
   if {$typeprop == "Constant"} {
      set value [GiD_AccessValue get material $matname $value]
      set mocmoc "$indent$key: $value"
      return $mocmoc
      #return "GiD_AccessValue get material $matname $table"
      #return $mytable(1) $mytable(2) $mytable(3)
   } else {
      set mytable [GiD_AccessValue get material $matname $table]
      set mytable [regexp -all -inline {\S+} $mytable]
      set mocmoc "$indent$key: DEPENDENT\n"
      set npoin [expr [lindex $mytable 1]/2]
      set mocmoc "$mocmoc$indent  NPOIN $npoin\n"
      for { set a 1}  {$a <= [expr $npoin]} {incr a} {
         set mocmoc "$mocmoc$indent  [lindex $mytable [expr 1+2*($a-1)+1]] [lindex $mytable [expr 1+2*($a-1)+2]]\n"
      }
      set endkey "END_$key"
      set mocmoc "$mocmoc$indent$endkey"
      #[lindex $mytable 0] [lindex $mytable 1] [lindex $mytable 2] [lindex $mytable 3] [lindex $mytable 4]"
      return $mocmoc
   }
}









